<template>
    <div class="text-end px-2">
        <button title="Guardar Cupos" type="button" class="btn btn-secondary p-1 px-2"
            @click="guardar()">
            <i class="bi bi-save fs-6 me-1"></i> Guardar
        </button>
    </div>

    <h6 class="mt-2 ps-3"> SOLICITANTE: <b> {{ data.solicitante?.ayn }} </b></h6>

    <div class=" d-md-flex align-items-center flex-wrap justify-content-start p-3 contenedorPrincipal m-3">


        <div class="col-2 ms-3">

            <label class="form-label">Fecha:</label>
            <input readonly type="date" v-model="data.fecha_hoy" class="d-bloc w-100" id="f_hoy" autocomplete="off"/>

        </div>

        <div class="col-3 ms-3 ">
            <label class="form-label">Importe Total:</label>
            <InputCurrency readonly class="form-control" v-model="totalTransferencia" :disabled="false" />
        </div>


        <div class="col-4 ms-3 mt-3">
            <label class="form-label">Observaciones:</label>
            <textarea placeholder="Escriba una observacion" type="text" v-model="data.observaciones" class="form-control"
                id="observ"> </textarea>
        </div>
        <div class="col-4 ms-3 mt-3">
            <label v-show="enableComponent" class="form-label me-2">Importe Transferido desde Subsidios:</label>
            <InputCurrency v-show="enableComponent" readonly class="form-control" v-model="data.total" :disabled="false" />
        </div>
    </div>


    <table class="table table-striped mt-4" v-if="cuposStore.cupos.length > 0">
        <thead>
            <tr>
                <th scope="col">Fecha</th>
                <th scope="col">Monto Otorgado</th>
                <th scope="col">Monto Gastado</th>
                <th scope="col">Monto Disponible</th>
                <th scope="col">Transfiere</th>
            </tr>
        </thead>
        <tbody>
            <!--  -->
            <tr v-for="transf in transferencias">
                <td v-text="formatDate(transf.fecha_cupo)"></td>
                <td v-text="'$' + formatPrice(transf.monto_otorgado)"></td>
                <td v-text="'$' + formatPrice(transf.monto_gastado)"></td>
                <td v-text="'$' + formatPrice(transf.monto_disponible)"></td>
                <td>
                    <InputCurrency class="form-control mb-2" :class="{ 'bg-danger': !transf.valido }"
                        v-model="transf.transfiere" :disabled="false" />
                </td>
            </tr>
        </tbody>
    </table>
    <div v-else class="alert alert-secondary" role="alert">
        No hay elementos para mostrar
    </div>
</template>

<script setup lang="ts">
//librerias
import { reactive, computed, onMounted, ref, type Ref } from "vue";
import { useRoute, useRouter } from "vue-router";
import http from "@/http";
import { loading, urlApi } from "@/shared.js";
import Swal from "sweetalert2/dist/sweetalert2.js";
import { InputCurrency } from "@hcd-bsas/vue3-components";
import { DateTime } from "luxon";
//Entities
import Solicitante from "@/entities/Solicitante";
// Stores
import { useConfigStore } from "@/stores/configgral";
import { useTransferenciasStore } from "@/stores/transferencias/transferencias";
import { useUsuariosStore } from "@/stores/usuarios";
import { useCuposStore } from "@/stores/becas/cupos";//este es el de facu no el mio
import type Cupo from "@/entities/becas/Cupo";

const transferenciaStore = useTransferenciasStore();
const configStore = useConfigStore();
const cuposStore = useCuposStore();
const usuarioStore = useUsuariosStore();

const router = useRouter();
const route = useRoute();

var data = reactive({
    solicitante: undefined as Solicitante | undefined,
    tipo_transf: "J" as string,
    fecha_hoy: "" as string | null,
    observaciones: "" as string,
    total: 0 as number,
    id_transferencia: null as number | null,
});

var fechas = reactive({
    anioActivo: "",
    f_cupo_des: "",
    f_cupo_has: ""
});

const enableComponent = computed(() => {
    if (data.tipo_transf !== 'B') {
        return false;
    } else { return true; }
});


var transferencias: Ref<Cupo[]> = ref([]);

onMounted(async () => {
    loading.show();
    var periodo = route.params.periodo;
    var id_tabla_sol = route.params.id_tabla_sol;
    await configStore.updateListadoPeriodo();
    fechas.anioActivo = configStore.listadoPeriodoActivo[0]?.anioActivo;
    fechas.f_cupo_des = periodo + '-03-01';
    fechas.f_cupo_has = fechas.anioActivo + '-12-31';

    await Promise.all([
        transferenciaStore.updateListadoTransferencias({
            listar_sin_cupo_por_cargo: '1'
        }),
        cuposStore.fetchCupos({
            f_cupo_des: fechas.f_cupo_des,
            f_cupo_has: fechas.f_cupo_has,
            id_tabla_sol: id_tabla_sol,
        }),
    ]);

    transferencias.value = cuposStore.getCupos();

    var now = DateTime.now().toFormat('yyyy-LL-dd');
    data.fecha_hoy = now;

    if (typeof id_tabla_sol === "string") {
        data.solicitante = await usuarioStore.findSolicitanteById(parseInt(id_tabla_sol));
    }

    loading.hide();
});

const totalTransferencia = computed(() => {
    let total = 0;
    transferencias.value.forEach(element => {
        element.valido = true;
        if (data.tipo_transf == 'J') {
            if (element.transfiere > element.monto_disponible) {
                element.valido = false;
                console.log("NO TIENE SALDO DISPONIBLE");
            } else {
                total += element.transfiere;
            }
        } else {
            total += element.transfiere;
        }
    });
    return total;
});

function formatDate(date: string | null) {
    if (date != null) {
        return DateTime.fromISO(date).toLocaleString();
    }
}

function formatPrice(value: any) {
    let val = (value / 1).toFixed(2).replace('.', ',')
    return val.toString().replace(/\B(?=(\d{3})+(?!\d))/g, ".")
}

async function guardar() {

    var array_periodo_monto = "";
    try {
        transferencias.value.forEach((element) => {
            if (element.transfiere > 0) {
                if (data.tipo_transf == 'J' && element.transfiere > element.monto_disponible) {
                    array_periodo_monto = "";
                    throw { message: "El monto a transferir para la fecha " + formatDate(element.fecha_cupo) + " supera el monto disponible." };
                }
                array_periodo_monto += element.fecha_cupo + ";" + element.transfiere + "|";
            }
        });
    } catch (error: any) {
        Swal.fire({
            icon: "error",
            text: error.message,
        });
    }

    if (array_periodo_monto == "") {
        return false;
    }

    await http.post(urlApi + "addCupoSolicitanteGrabar", {
        tipo_transf: data.tipo_transf,
        accion: "A",
        f_periodo: fechas.anioActivo,
        id_tabla_sol: data.solicitante?.id_tabla_sol,
        monto: totalTransferencia.value,
        f_desde: fechas.f_cupo_des,
        f_hasta: fechas.f_cupo_has,
        array_periodo_monto: array_periodo_monto,
        observaciones: data.observaciones,
        id_transferencia: data.id_transferencia,
        id_tabla_sol_reemp: Number(data.solicitante?.id_tabla_sol_reemplaza),
    }).then(async () => {
        router.push({
            name: "ajusteBajaSolicitante",
            params: { id_tabla_sol: data.solicitante?.id_tabla_sol },
        });
        Swal.fire({
            icon: "success",
            text: "Se grabo la Transferencia.",
        })
        loading.hide();
    }).catch(function (error) {
        console.log(error);
        Swal.fire({
            icon: "error",
            text: error.response.data.message.replace("Error al ejecutar la operación solicitada en la base de datos. Por favor, avise al Administrador. Mensaje de la excepción de Microsoft SQL Server:", ""),
        });
        loading.hide();
    });

}

</script>
